#include <stdio.h>
void countWays(int, int*, int);
int main() {
    int n;
    printf("Enter the number of stairs (excluding the first floor): ");
    scanf("%d", &n);
    printf("William can reach the x step in the following ways:\n");
    int path[n];
    countWays(n, path, 0);
    return 0;
}
void countWays(int n, int path[], int index) {
    if (n == 0) {
        // we have reached the next floor
        printf("1");
        for (int i = 0; i < index; i++) {
            printf("-%d", path[i]);
        }
        printf("\n");
        return;
    }
    if (n >= 1) {
        // take one step
        path[index] = 1;
        countWays(n-1, path, index+1);
    }
    if (n >= 2) {
        // skip one step
        path[index] = 2;
        countWays(n-2, path, index+1);
    }
}


